unit uServerMethods;

interface

uses System.SysUtils, System.Classes, Datasnap.DSServer, Datasnap.DSAuth,
  UniProvider, PostgreSQLUniProvider, Data.DB, MemDS, DBAccess, Uni;

type
  TServerMethods = class(TDSServerModule)
    UniConnection: TUniConnection;
    uqDept: TUniQuery;
    uqEmp: TUniQuery;
    PostgreSQLUniProvider: TPostgreSQLUniProvider;
    usp_check_user: TUniStoredProc;
    usp_dept_modify: TUniStoredProc;
    usp_emp_modify: TUniStoredProc;
  private
    { Private declarations }
  public
    { Public declarations }
    function GetDept: TDataSet;
    function GetEmp(DeptNo: integer = -1): TDataSet;
    function CheckUser(username: string = ''; passwd: string = ''):boolean;
    procedure DeptModify(DeptNo: integer = -1; DName: string = ''; Loc: string = ''; op_type: integer = 0);
    procedure EmpModify(Empno: integer = -1;
                        EName: string = '';
                        Job: string = '';
                        Mgr: integer = 0;
                        HireDate: TDateTime = 0;
                        Sal: double = 0;
                        Comm: double = 0;
                        Deptno:integer = -1;
                        op_type: integer = 0);
  end;

var
  ServerMethods: TServerMethods;

implementation

{$R *.dfm}

{ TServerMethods }

function TServerMethods.GetDept: TDataSet;
begin
  uqDept.Close;
  uqDept.Open;
  Result := uqDept;
end;

function TServerMethods.GetEmp(DeptNo: integer): TDataSet;
begin
  uqEmp.Close;
  uqEmp.ParamByName('DEPTNO').AsInteger := DeptNo;
  uqEmp.Open;
  Result := uqEmp;
end;

function TServerMethods.CheckUser(username: string; passwd: string): boolean;
begin
  usp_check_user.ParamByName('a_username').AsString := username;
  usp_check_user.ParamByName('a_passwd').AsString := passwd;
  usp_check_user.Execute;
  Result := usp_check_user.ParamByName('result').AsBoolean;
end;

procedure TServerMethods.DeptModify(DeptNo: integer; DName: string; Loc: string; op_type: integer);
begin
  usp_dept_modify.ParamByName('a_deptno').AsInteger := DeptNo;
  usp_dept_modify.ParamByName('a_dname').AsString := DName;
  usp_dept_modify.ParamByName('a_loc').AsString := Loc;
  usp_dept_modify.ParamByName('a_op_type').AsInteger := op_type;
  usp_dept_modify.Execute;
end;

procedure TServerMethods.EmpModify(Empno: integer; EName, Job: string;
  Mgr: integer; HireDate: TDateTime; Sal, Comm: double; Deptno, op_type: integer);
begin
  usp_emp_modify.ParamByName('a_empno').AsInteger := Empno;
  usp_emp_modify.ParamByName('a_ename').AsString := EName;
  usp_emp_modify.ParamByName('a_job').AsString := Job;
  usp_emp_modify.ParamByName('a_mgr').AsInteger := Mgr;
  usp_emp_modify.ParamByName('a_hiredate').AsDateTime := HireDate;
  usp_emp_modify.ParamByName('a_sal').AsFloat := Sal;
  usp_emp_modify.ParamByName('a_Comm').AsFloat := Comm;
  usp_emp_modify.ParamByName('a_deptno').AsInteger := Deptno;
  usp_emp_modify.ParamByName('a_op_type').AsInteger := op_type;
  usp_emp_modify.Execute;
end;

end.

